from hecuba import StorageObj
import random
import traceback


# datamodel
class FesomOutput_2D(StorageObj):
    '''
    @ClassField ID str
    @ClassField glsize int
    @ClassField lcsize int
    @ClassField name str
    @ClassField description str
    @ClassField units str
    @ClassField freq float
    @ClassField freq_unit str
    @ClassField accuracy int
    '''


# method to store in Hecuba
def store_data(**kwargs):
    # add checks for determine existence of the valuee
    # instantiate the object
    try:
        fesom_2d_output = FesomOutput_2D()
        fesom_2d_output.ID = str(random.randint(0, 999))
        fesom_2d_output.glsize = kwargs["glsize"]
        fesom_2d_output.lcsize = kwargs["lcsize"]
        fesom_2d_output.name = kwargs["name"]
        fesom_2d_output.description = kwargs["description"]
        fesom_2d_output.units = kwargs["units"]
        fesom_2d_output.freq = kwargs["freq"]
        fesom_2d_output.freq_unit = kwargs["freq_unit"]
        fesom_2d_output.accuracy = kwargs["accuracy"]
        # save to Hecuba
        fesom_2d_output.make_persistent(kwargs["name"])

        print("Data saved to Hecuba")
        result = "OK"
    except Exception as error:
        print(traceback.format_exc())
        result = "KO"
    finally:
        return result

# method to retrieve data from in Hecuba
def retrieve_data(**kwargs):
    try:
        # add checks for determine existence of the valuee
        # instantiate the object
        var_key = str(kwargs["key"])
        fesom_2d_var = FesomOutput_2D.get_by_alias(var_key)
        print(fesom_2d_var.name)

        print("Data retrieved successfully to Hecuba")
        result = "OK"
    except Exception as error:
        print(traceback.format_exc())
        result = "KO"
    finally:
        return result



